static char *RCSid = "$Header: /sequent2/empire/EMP/lib/global/RCS/plane.c,v 1.1 89/09/02 18:30:21 mr-frog Exp $";

/*
 * plane.c
 *
 * plane characteristics
 * flags indicate capabilities of craft...
 * P_T: tactical, P_F: fighter/interceptor, P_B: bomber,
 * P_C: cargo, P_G: glider, P_V: vtol, P_M: (one-shot) missile
 * P_L: light, can land on carriers.
 * 
 */

#include "misc.h"
#include "plane.h"

struct plchrstr plchr[] = {
/*       name          lcm hcm $$$ tech acc load att/def ran mil gas flags */
	"fighter 1",	 8, 2, 400, 40, 30,  1,  3,  2,  6,  1,  1, P_V|P_T|P_F|P_L,
	"lt bomber 1",	10, 3, 550, 40, 30,  2,  1,  2,  8,  2,  1, P_V|P_T|P_B|P_L,
	"transport 1",	12, 5, 800, 45,  0,  7,  0,  1, 15,  2,  2, P_C,
	"hvy bomber 1",	20, 6,1100, 50, 85,  6,  2,  3, 15,  3,  2, P_B,
	"long bomber 1",20, 6,1100, 60,120,  2,  0,  1, 30,  4,  4, P_B,
	"fighter 2",	10, 6, 800, 70, 25,  1,  6,  4,  8,  1,  1, P_T|P_F|P_L,
	"lt bomber 2",	12, 8, 900, 70, 25,  3,  2,  3, 12,  2,  1, P_T|P_B|P_L,
	"escort 2",	12, 5, 850, 75,  0,  0,  4,  4, 16,  1,  2, P_F|P_L,
	"chopper 1",	10, 4, 900, 75,  0,  5,  0,  2,  8,  1,  1, P_C|P_V|P_L,
	"transport 2",	14,10,1200, 80,  0,  9,  0,  2, 20,  3,  3, P_C,
	"long transport",14,10,1200,80,  0,  3,  0,  1, 35,  4,  5, P_C,
	"hvy bomber 2",	20,15,2000, 90, 75, 10,  3,  5, 20,  9,  3, P_B,
	"long bomber 2",20,15,2000, 95, 75,  4,  2,  2, 35,  6,  5, P_B,
	"jet fighter",	16, 5,2200,120, 40,  2, 12,  8,  9,  1,  4, P_T|P_F|P_L,
	"jet lt bomber",14, 7,1500,120, 20,  5,  5,  8, 15,  2,  5, P_T|P_B|P_L,
	"jet hvy bomber",35,20,5200,140,65, 16,  4, 10, 40,  8,  8, P_B,
	"jet transport",30,20,2100,140,  0, 16,  0,  5, 40,  4,  7, P_C,
	"jet fighter 2",16, 5,2000,200, 30,  2, 12,  8,  9,  1,  5, P_T|P_F|P_V|P_L,
	"jet f/b",	12, 5,3500,210, 40,  8, 10, 10, 32,  2,  6, P_B|P_T,
	"spyplane 1",	15,10,3000,190,  0,  0,  0,  7, 40,  1,  5, P_S,
	"spyplane 2",	18,13,4500,275,  0,  0,  0, 12, 60,  2,  8, P_S|P_I,
	"stealth bomber",45,35,9500,350,60, 12,  3, 12, 36,  3,  4, P_B|P_X,
	"stealth fighter",35,25,9500,350,30, 3, 15, 12, 20,  1,  3, P_T|P_F|P_X,
	"chopper 2",	15, 8,1000,180, 10,  3,  5,  5, 12,  1,  2, P_T|P_B|P_V|P_L,
	"chopper 3",	15,12,1100,180,  0,  6,  2,  3, 20,  4,  3, P_C|P_V|P_L,
	"chopper 4",	15,12,1500,265, 10,  5,  7,  7, 18,  2,  3, P_T|P_B|P_V|P_L,
	"ssm 1",	10, 6, 500,160, 60,  5,  0,  5,  6,  0,  0, P_M|P_L,
	"ssm 2",	12, 8, 600,200, 50,  7,  0,  6,  8,  0,  0, P_M|P_L,
/* XXX fix these later */
	"irbm 1",	15,15,1000,250, 60,  5,  0,  3, 15,  0,  7, P_M,
	"irbm 2",	18,18,2000,270, 50,  7,  0,  3, 18,  0,  8, P_M,
	"icbm 1",	30,30,3000,280, 70,  7,  0,  3, 40,  0,  9, P_M,
	"icbm 2",	45,45,4000,320, 50, 10,  0,  6, 50,  0, 10, P_M,
	"icbm 3",	60,60,5000,400, 20, 15,  0, 10, 60,  0, 11, P_M,
	"icbm 4",     100,100,9000,450, 20, 30,  0, 50 ,60,  0, 12, P_M,
	"slbm 1",	25,25,3000,260, 70,  7,  0,  3, 19,  0,  6, P_M|P_L,
	"slbm 2",	25,25,5000,360, 70, 11,  0,  3, 40,  0,  7, P_M|P_L,
	"sam 1",	25,25,300, 130, 30,  4, 12,  1,  5,  0,  6, P_M|P_F,
	"sam 2",	35,35,500, 230, 20,  4, 12,  1,  5,  0,  6, P_M|P_F|P_L,
	"sam 3",	45,45,1600,380, 10,  4, 14,  1, 15,  0,  6, P_M|P_F,
	"sam 4",	45,45,2000,480, 10,  4, 14,  1, 15,  0,  6, P_M|P_F|P_L,
	"landsat 1"	,20,20,8000,205, 0,  0,  0,  2, 99,  0,  9, P_O,
	"landsat 2"	,25,25,9500,305, 0,  0,  0,  2, 99,  0,  9, P_O|P_I,
	"spysat 1"	,30,30,25000,405,0,  0,  0,  2, 99,  0,  9, P_O|P_S,
	"spysat 2"	,35,35,30000,505,0,  0,  0,  2, 99,  0,  9, P_O|P_S|P_I,
	"anti-sat 1",  13, 8,  700,185, 70,  6,  0,  6,  8,  0,  4, P_O|P_M|P_L,
	"anti-sat 2",  15, 8,  800,235, 60,  8,  0,  6, 12,  0,  5, P_O|P_M|P_L,
	"anti-sat 3",  18, 8,  900,285, 50,  8,  0,  6, 20,  0,  6, P_O|P_M|P_L,
	"anti-sat 4",  35,35, 2500,335, 40, 16,  0,  6, 99,  0,  9, P_O|P_M,
	"",		0, 0,    0,  0,  0,  0,  0,  0,  0,  0,  0, 0,
/*       name          lcm hcm $$$ tech acc load att/def ran mil gas flags */
};

int	pln_maxno   = (sizeof(plchr) / sizeof(struct plchrstr)) - 1;
